require 'socket'
require 'timeout'

if ARGV.size < 2
  STDERR.print "Usage: ruby #{$0} user_name password [pop3_server]\n"
  exit
end
user_name = ARGV[0]
password  = ARGV[1]
pop3_serv = if ARGV[2] then ARGV[2] else 'localhost' end

sock = nil
timeout(30) {
  sock = TCPSocket.new(pop3_serv, 'pop3')
}

def sock.wait_ok(message)
  write message if message
  reply = nil
  timeout(10) {
    reply = self.gets
  }
  case reply
  when /^\+OK/
    return reply[4..-1]
  else
    return false
  end
end

sock.wait_ok(nil)  # ignore greeting message

if sock.wait_ok("USER #{user_name}\n") and 
    sock.wait_ok("PASS #{password}\n") and
    stat = sock.wait_ok("STAT\n")
  mail, size = stat.scan(/[^ ]+/).collect{|n| n.to_i}
  print "You have #{mail} message(s) [ #{size} octet(s) ].\n"
else
  print "Fail to get POP3 STAT.\n"
end

sock.wait_ok "QUIT\n"
sock.close
